<template>
  <div ref="searchBox" class="search-box">
    <i class="icon-search"></i>
    <input
      v-bind="$attrs"
      ref="search"
      type="search"
      @input="onInput"
      @keydown.enter="onChange"
      @blur="onChange"
      @focus="openTips"
      @click="openTips"
    />
    <ul v-show="isOpen && tips.length" class="search-autocomplite">
      <li v-for="(tip, idx) in tips" :key="idx">
        <nuxt-link :to="`/showroom/${tip.path}`" class="d-block">{{
          tip.name
        }}</nuxt-link>
      </li>
    </ul>
  </div>
</template>

<script>
import { debounce } from '@/mixins/utils'

const debouncedEndpointRequest = debounce(async function (term) {
  this.tips = await this.requestTips(term)
}, 400)
export default {
  name: 'InputSearch',
  inheritAttrs: false,
  props: {
    // Функция, которая возвращает промис c массивом строк
    requestTips: {
      type: Function,
      required: false,
      default: () => Promise.resolve([]),
    },
  },
  data() {
    return {
      tips: [],
      isOpen: false,
    }
  },
  mounted() {
    window.onclick = (e) => {
      if (!this.$refs.searchBox.contains(e.target)) {
        this.closeTips()
      }
    }
  },
  destroyed() {
    window.onclick = null
  },
  methods: {
    onTipSelect(tip) {
      this.$emit('input', tip)
      this.$emit('change', tip)
    },
    onChange(e) {
      this.$emit('change', e.target.value)
    },
    onInput(e) {
      this.$emit('input', e.target.value)
      debouncedEndpointRequest.call(this, e.target.value)
    },
    openTips() {
      this.isOpen = true
    },
    closeTips() {
      this.isOpen = false
    },
  },
}
</script>

<style scoped>
input::-webkit-search-cancel-button {
  display: none;
}
</style>
